4d8c27d6347042723f948c445f1fa9f36c7d5831
[csit.git] / resources / libraries / bash / entry / check / pylint.sh
1 # Copyright (c) 2021 Cisco and/or its affiliates.
2 # Licensed under the Apache License, Version 2.0 (the "License");
3 # you may not use this file except in compliance with the License.
4 # You may obtain a copy of the License at:
5 #
6 #     http://www.apache.org/licenses/LICENSE-2.0
7 #
8 # Unless required by applicable law or agreed to in writing, software
9 # distributed under the License is distributed on an "AS IS" BASIS,
10 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
11 # See the License for the specific language governing permissions and
12 # limitations under the License.
13
14 set -exuo pipefail
15
16 # This file should be executed from tox, as the assumend working directory
17 # is different from where this file is located.
18 # This file does not have executable flag nor shebang,
19 # to dissuade non-tox callers.
20
21 # This script runs pylint and propagates its exit code.
22 # Config is taken from pylint.cfg, and proper virtualenv is assumed to be active.
23 # The pylint output stored to pylint.log (overwriting).
24
25 # "set -eu" handles failures from the following two lines.
26 BASH_CHECKS_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
27 BASH_FUNCTION_DIR="$(readlink -e "${BASH_CHECKS_DIR}/../../function")"
28 source "${BASH_FUNCTION_DIR}/common.sh" || {
29     echo "Source failed." >&2
30     exit 1
31 }
32 pylint_args=("--rcfile=pylint.cfg" "resources/" "GPL/")
33 if pylint "${pylint_args[@]}" > "pylint.log"; then
34     warn
35     warn "Pylint checker: PASS"
36 else
37     # TODO: Decide which text goes to stdout and which to stderr.
38     warn "Pylint exited with nonzero status."
39     ## TODO: Enable when output size does more good than harm.
40     # cat "pylint.log" >&2
41     warn
42     warn "Pylint checker: FAIL"
43     exit 1
44 fi